INCLUDED4:EFT36D.ASM
;
;EFT  VERSION 36I (INTERRUPT ROUTINES) JANUARY 29, 1983
;
VBISRVLDARTCLKL
AND#$1F
BNEX44
LDACHART
EOR#2
STACHART
X44LDATRIG0;button status
ORABUTMSK;button allowed?
BEQX17
LDABUTFLG;no button now; previous status
BNEX23
JMPNOBUT
X23LDA#$3A;button just released
STAPCOLR0
LDA#0
STABUTFLG
STAKRZFLG
STAAUDC1
LDYLEVEL
CPY#4
BNEX89
STABUTLAG
X89LDX#$52
LOOP8STATXTWDW+8,X;clear text window
DEX
BPLLOOP8
JSRWDWCLR
;
LDX#NOGERM-1
LOOP86LDATOUCHD,X
BNEY45
DEX
BNELOOP86
STAREINSP
Y45LDA#8
STADELAY
CLC
ADCRTCLKL
STATIMSCL
JSRSWITCH
LDA#0
STACORPS
JSRCLRP1
JSRCLRP2
JMPENDISR
X17STAATRACT;button is pressed
LDASTICK
AND#$F
EOR#$F
BEQX20;joystick active?
JMPORDERS;yes
X20STADBTIMR;no, set debounce
STAAUDC1
STASTKFLG
LDABUTFLG
BNEBUTHLD;is this the first button pass
JMPFBUTPS;yes
BUTHLDJSRERRCLR;no, clear errors
LDAHITFLG
BEQX63;anybody in the window?
X96JMPENDISR;no
X63LDABUTLAG
CMP#LAGTIM
BCCX96
LDACH
CMP#$21
BNEX80;space bar pressed?
LDXCORPS;yes, check for Russian
CPX#NOGERM
BCSX80
LDA#0
STACH
STAHMORDS,X;clear out orders
STAHOWMNY
STASTPCNT
LDA#1
STAORDCNT
JSRCLRP1
JSRCLRP2
LDABASEX
STASTEPX
LDABASEY
STASTEPY
X80LDARTCLKL
AND#3
BEQX54;time to move arrow?
JMPENDISR;no
X54LDYHOWMNY;yes
BNEX65;any orders to show?
JMPPCURSE;no, go ahead to maltakreuze
X65JSRCLRP1;yes, clear old arrow
LDAORDCNT
LDX#0;assume first byte
CMP#5
BCCX52;second byte or first?
INX;second byte
X52AND#3;isolate bit pair index
TAY
LDABITTAB,Y;get mask
ANDORD1,X;get orders
;
;right justify orders
;
DEY
BPLX51
LDY#3
X51BEQX53
LOOP21LSRA
LSRA
DEY
BNELOOP21
X53STAARRNDX
ASLA
ASLA
ASLA
;get arrow image and store it to player RAM
TAX
LDYSTEPY
X55LDAARRTAB,X
CPY#$80
BCSX43
STAPLYR1,Y
X43INX
INY
TXA
AND#7
BNEX55
;
LDASTEPX;position arrow
STAHPOSP1
;
;now step arrow
;
LDXARRNDX
LDASTEPX
CLC
ADCXADD,X
STASTEPX
LDASTEPY
CLC
ADCYADD,X
STASTEPY
;
INCSTPCNT;next step
LDASTPCNT
AND#7
BNEX59;if not done end ISR
STASTPCNT;end of steps
INCORDCNT;next order
LDAORDCNT
CMPHOWMNY;last order?
BCCX59;no, out
BEQX59;no, out
LDA#1
STAORDCNT;yes, reset to start of arrow's path
;
;display maltese cross ('maltakreuze' or KRZ)
;
PCURSELDYSTEPY
LDA#$FF
STAKRZFLG
LDASTEPX
SEC
SBC#1
TAX
JSRMOVKRZ
JSRCLRP1;clear arrow
LDABASEX;reset arrow's coords
STASTEPX
LDABASEY
STASTEPY
;
X59JMPENDISR
;
;FIRST BUTTON PASS
;looksfor a unit inside cursor
;if there is one, puts unit info into text window
;
FBUTPSLDA#$FF
STABUTFLG
;
;first get coords of center of cursor (map frame)
;
JSRCALCHK
;
;check for city match
;
LDX#18
LOOP99CMPMOSCY,X
BEQX32
Z66DEX
BPLLOOP99
BMIZ79
X32LDACHUNKX
CMPMOSCX,X
BEQX37
LDACHUNKY
JMPZ66
X37JSRWDWCLR
LDYCNOFF,X
LDX#MSGPLC+10
SEC
LOOP98LDACNAMTB,Y
SBC#$20
BPLZ78
AND#$7F
STATXTWDW,X
BNEZ79
Z78STATXTWDW,X
INY
INX
BNELOOP98
;
;now look for a match with unit coordinates
;
Z79JSRSW2
STYFROG
LDX#0
AND#$3F
CMP#$3C
BCCX56
CMP#$3F
BCSX56
LDX#NOUNTS
LDA(MAPLO),Y
BMIX57
LDX#NOGERM-1
X57LDACHUNKY
LOOP6CMPCORPSY,X
BEQMAYBE
X16DEX
BNELOOP6
X56STXCORPS;no match obtained
DEX
STXHITFLG
JMPENDISR
;
MAYBELDACHUNKX
CMPCORPSX,X
BNEX35
LDAARRIVE,X
BMIX35
CMPTURN
BCCMATCH1
BEQMATCH1
X35LDACHUNKY
JMPX16
;
;match obtained
;
MATCH1LDA#0
STAHITFLG;note match
STACH
LDA#$46
CPX#NOGERM
BCSZ34
LDA#$E
Z34STAPCOLR0;light up cursor
;
;display unit specs
;
STXCORPS
LDY#9
LDACORPNO,X;ID number
JSRDNUMBR
INY
LDXCORPS
LDACORPT,X;first name
PHA
AND#$70
LSRA
LSRA
LSRA
LSRA
JSRDWORDS
PLA
AND#7;second name
ORA#8
JSRDWORDS
LDX#6
LDACORPS
CMP#NOGERM
BCSX26
LDX#1
X26JSRDWORDX;display unit type
LDALEVEL
CMP#4
BNEX49
LDXCORPS
LDAMODE,X
CLC
ADC#21
LDY#MODPLC
JSRDWORDS
LDY#$56
LDX#25
JSRDWORDX
X49LDY#$39
LDX#10;"MUSTER"
JSRDWORDX
DEY
LDA#$1A;":"
STATXTWDW,Y
INY
INY
LDXCORPS
LDAMSTRNG,X;muster strength
JSRFOGUP
INY
INY
LDX#15;"COMBAT"
JSRDWORDX
DEY
LDA#$1A;":"
STATXTWDW,Y
INY
INY
LDXCORPS
LDACSTRNG,X;combat strength
JSRFOGUP
LDYFROG
JSRSWITCH+3;flip unit with terrain
CPX#NOGERM
BCCX79;Russian?
LDA#$FF;yes, mask orders and exit
STAHITFLG
BMIX75
;
;German unit
;set up orders display
;first calculate starting coords (BASEX, BASEY)
;
X79LDABUTLAG
CMP#LAGTIM
BCSX87
INVMODLDY#MODPLC
LOOP85LDATXTWDW,Y
BEQX75
ORA#$80
STATXTWDW,Y
INY
BNELOOP85
JMPENDISR
X87LDA#1
STAORDCNT
LDA#30
STARPTIMR
LDA#0
STASTPCNT
STATOUCHD,X
;
JSRCALBAS
;
;now set up page 0 values
;
LDAHMORDS,X
STAHOWMNY
LDAWHORDS,X
STAORD1
LDAWHORDH,X
STAORD2
X75JMPENDISR
;
;ORDERS INPUT ROUTINE
;
ORDERSLDAENDFLG
BNEX75
LDASTKFLG
BEQZ89
DECRPTIMR
BPLX75
LDA#0
STASTKFLG
STAAUDC1
LDA#4
STARPTIMR
Z89LDXCORPS
BNEX81
LDX#5
JMPSQUAWK
X81CPX#NOGERM
BCCX64;Russian?
LDX#0;yes, error
JMPSQUAWK
X64LDABUTLAG
CMP#LAGTIM
BCSY10
LDYSTICK
LDASTKTAB,Y
BMIY11
CPX#NOFLIG
BCCY03
CMP#1
BEQY03
CMP#2
BEQY03
LDX#7
JMPSQUAWK
Y03TAY
LDABEEPTB,Y
ASLA
STAAUDF1
LDA#$A8
STAAUDC1
CPY#3
BNEY17
LDA#0
STAHMORDS,X
Y17TYA
STAMODE,X
CLC
ADC#21
LDY#MODPLC
JSRDWORDS
STATXTWDW,Y
INY
STATXTWDW,Y
INY
STATXTWDW,Y
JMPINVMOD
Y10LDAMODE,X
CMP#3
BNEY42
LDX#6
JMPSQUAWK
Y42LDAHMORDS,X
CMP#8
BCCX66;only 8 orders allowed
LDX#1
JMPSQUAWK
X66LDAKRZFLG
BNEX67;must wait for maltakreuze
LDX#2
JMPSQUAWK
X67INCDBTIMR
LDADBTIMR;wait for debounce time
CMP#$10
BCSX68
JMPENDISR
X68LDA#0
STADBTIMR;reset debounce timer
LDYSTICK
LDASTKTAB,Y
BPLX69
Y11LDX#3;no diagonal orders allowed
JMPSQUAWK
;
;OK, this is a good order
;
X69TAY
STASTICKI
LDABEEPTB,Y
STAAUDF1;"BEEP!"
LDA#$A8
STAAUDC1
LDA#$FF
STASTKFLG
;
INCHMORDS,X
LDAHMORDS,X
STAHOWMNY
SEC
SBC#1
AND#3
TAY
STYTEMPI
LDAHMORDS,X
SEC
SBC#1
LSRA
LSRA
TAX
LDASTICKI
;isolate order
X71DEY
BMIX70
ASLA
ASLA
JMPX71
X70LDYTEMPI
EORORD1,X;fold in new order (sneaky code)
ANDMASKO,Y
EORORD1,X
STAORD1,X
LDAORD1
LDXCORPS
STAWHORDS,X
LDAORD2
STAWHORDH,X
;
;move maltakreuze
;
JSRCLRP2
LDXSTICKI
LDAKRZY
CLC
ADCYOFF,X
TAY
LDAKRZX
CLC
ADCXOFF,X
TAX
JSRMOVKRZ
BEQEXITI
;
;ERROR on inputs routine
;squawks speaker and puts out error message
;
SQUAWKJSRERR1
LDA#$66
STAAUDC1
LDA#$50
STAAUDF1;"HONK!"
LDA#$FF
STAERRFLG
BMIEXITI
;
;NO BUTTON PRESSED ROUTINE
;
NOBUTINCBUTLAG
BNEX84
DECBUTLAG
X84STADBTIMR
LDASTICK
AND#$F
EOR#$F
BNESCROLL
STAAUDC1
STASTKFLG
LDA#8
STADELAY
CLC
ADCRTCLKL
STATIMSCL
JSRERRCLR
EXITIJMPENDISR
SCROLLLDA#0
STAATRACT
;
;acceleration feature of cursor
;
LDATIMSCL
CMPRTCLKL
BNEEXITI
LDADELAY
CMP#1
BEQX21
SEC
SBC#1
STADELAY
X21CLC
ADCRTCLKL
STATIMSCL
;
LDA#0
STAOFFLO
STAOFFHI;zero the offset
;
LDASTICK;get joystick reading
PHA;save it on stack for other bit checks
AND#8;joystick left?
BNECHKRT;no, move on
LDACURSXL
BNEX13
LDXCURSXH
BEQCHKUP
X13SEC
SBC#1
STACURSXL
BCSX14
DECCURSXH
X14LDASHPOS0
CMP#$BA
BEQX1
ADC#1
STASHPOS0
STAHPOSP0
BNECHKUP
X1DECXPOSL
LDAXPOSL
AND#7
STAHSCROL;fine scroll
CMP#7;scroll overflow?
BNECHKUP;no, move on
INCOFFLO;yes, mark it for offset
CHKRTPLA;get back joystick byte
PHA;save ;it again
AND#4;joystick right?
BNECHKUP;no,move on
LDACURSXL
CMP#$64
BNEX12
LDXCURSXH
BNECHKUP
X12CLC
ADC#1
STACURSXL
BCCX15
INCCURSXH
X15LDASHPOS0
CMP#$36
BEQX2
SEC
SBC#1
STASHPOS0
STAHPOSP0
BNECHKUP
X2INCXPOSL
LDAXPOSL
AND#7
STAHSCROL;fine scroll
BNECHKUP;scrolloverflow? if not, move on
DECOFFLO;yes, set up offset for character scroll
DECOFFHI
CHKUPPLA;joystick up?
LSRA
PHA
BCSCHKDN;no, ramble on
LDACURSYL
CMP#$5E
BNEX3
LDXCURSYH
CPX#2
BEQCHKDN
X3INCCURSYL
BNEX11
INCCURSYH
X11LDXSCY
CPX#$1B
BEQX6
INCCURSYL
BNEX18
INCCURSYH
X18DEX
STXSCY
TXA
CLC
ADC#$12
STATEMPI
LOOP4LDAPLYR0,X
STAPLYR0-1,X
INX
CPXTEMPI
BNELOOP4
BEQCHKDN
X6LDAYPOSL
SEC
SBC#1
BCSX7
DECYPOSH
X7STAYPOSL
AND#$F
STAVSCROL;fine scroll
CMP#$F
BNECHKDN;scroll overflow? If not, amble on
LDAOFFLO;yes, set up offset for character scroll
SEC
SBC#$30
STAOFFLO
LDAOFFHI
SBC#0
STAOFFHI
CHKDNPLA;joystick down?
LSRA
BCSCHGDL;no, trudge on
LDACURSYL
CMP#2
BNEX5
LDXCURSYH
BEQCHGDL
X5SEC
SBC#1
STACURSYL
BCSX10
DECCURSYH
X10LDXSCY
CPX#$4E
BEQX8
SEC
SBC#1
STACURSYL
BCSX19
DECCURSYH
X19INX
STXSCY
TXA
CLC
ADC#$12
DEX
DEX
STXTEMPI
TAX
LOOP5LDAPLYR0-1,X
STAPLYR0,X
DEX
CPXTEMPI
BNELOOP5
BEQCHGDL
X8INCYPOSL
LDAYPOSL
BNEX9
INCYPOSH
X9AND#$F
STAVSCROL;fine scroll
BNECHGDL;no, move on
LDAOFFLO;yes, mark offset
CLC
ADC#$30
STAOFFLO
LDAOFFHI
ADC#0
STAOFFHI
;
;In this loop we add the offset values to the existing
;LMS addresses of all display lines.
;This scrolls the characters.
;
CHGDLLDY#9
DLOOPLDA(DLSTPT),Y
CLC
ADCOFFLO
STA(DLSTPT),Y
INY
LDA(DLSTPT),Y
ADCOFFHI
STA(DLSTPT),Y
INY
INY
CPY#$27
BNEDLOOP
;
ENDISRLDAYPOSH
LSRA
LDAYPOSL
RORA
LSRA
LSRA
LSRA
CMP#$11
BCSX39
LDA#$FF
BMIX40
X39CMP#$1A
BCCX41
LDA#2
BPLX40
X41STATEMPI
LDA#$1D
SEC
SBCTEMPI
X40STACNT1
LDA#0
STACNT2
JMPXITVBV;exit vertical blank routine
;
;subroutine CALCHK
;
CALCHKLDACURSXL
CLC
ADC#6
STATXL
LDACURSXH
ADC#0
LSRA
LDATXL
RORA
LSRA
LSRA
STACHUNKX
;
LDACURSYL
CLC
ADC#9
STATYL
LDACURSYH
ADC#0
LSRA
TAX
LDATYL
RORA
TAY
TXA
LSRA
TYA
RORA
LSRA
LSRA
STACHUNKY
RTS
;
;subroutine CALBAS
;
CALBASLDATXL
AND#7
CLC
ADC#1
ADCSHPOS0
STABASEX
STASTEPX
;
LDATYL
AND#$F
LSRA
SEC
SBC#1
CLC
ADCSCY
STABASEY
STASTEPY
RTS
;
;subroutine MOVKRZ
;
MOVKRZSTXHPOSP2
STXKRZX
STYKRZY
LDX#0
LOOP26LDAMLTKRZ,X
CPY#$80
BCSX45
STAPLYR2,Y
X45INY
INX
CPX#8
BNELOOP26
RTS
;
;SUBROUTINE DWORDS
;displays a single word from a long table of words
;
DWORDSTAX
DWORDXLDAWRDLNG,X
TAX
SEC
LOOP20LDAWORDS,X
SBC#$20
STATXTWDW,Y
BEQNDW
INX
INY
BNELOOP20
NDWINY
RTS
;
;SUBROUTINE SWITCH FOR SWAPPING CORPS WITH TERRAIN
;
SWITCHJSRSW2
LDA(MAPLO),Y
LDXCORPS
BEQX34
PHA
LDASWAP,X
STA(MAPLO),Y
PLA
STASWAP,X
X34RTS
;
SW2LDA#0
STAMAPHI
LDA#$27
SEC
SBCCHUNKY
ASLA
ASLA
ASLA
ROLMAPHI
ASLA
ROLMAPHI
STATEMPLO
LDXMAPHI
STXTEMPHI
ASLA
ROLMAPHI
CLC
ADCTEMPLO
STAMAPLO
LDAMAPHI
ADCTEMPHI
ADCMAPBAS
STAMAPHI
LDA#46
SEC
SBCCHUNKX
TAY
LDA(MAPLO),Y
RTS
;
;SUBROUTINE CLRP1
;clears the arrow player
;
CLRP1LDA#0
LDYSTEPY
DEY
TAX
LOOP23CPY#$80
BCSX22
STAPLYR1,Y
X22INY
INX
CPX#$B
BNELOOP23
RTS
;
;SUBROUTINE CLRP2
;clears the maltakreuze
;
CLRP2LDA#0
LDYKRZY
TAX
LOOP25CPY#$80
BCSX42
STAPLYR2,Y
X42INY
INX
CPX#$A
BNELOOP25
RTS
;
GETCONLDA#8
STACONSOL
LDACONSOL
CMP#7
BEQZ69
STAATRACT
Z69RTS
;
;SUBROUTINE ERRCLR
;clears sound and the text window
;
ERRCLRLDAERRFLG
BPLENDERR
JSRWDWCLR
STAERRFLG
ENDERRRTS
;
WDWCLRLDA#0
LDY#MSGPLC+$1F
LOOP29STATXTWDW,Y
DEY
CPY#MSGPLC
BCSLOOP29
RTS
;
;This is the DLI routine
;
DLISRVPHA
TXA
PHA
INCCNT2
LDACNT2
CMPCNT1
BNEOVER1
LDX#[CHRSET+512]/256;mapDLI
LDA#$28
EORCOLRSH
ANDDRKMSK
STAWSYNC
STXCHBASE
STACOLPF0
JMPDLIOUT
;
OVER1CMP#$F
BNEOVER6
LDA#$3A
EORCOLRSH
ANDDRKMSK
TAX
LDA#0
EORCOLRSH
ANDDRKMSK
STAWSYNC
STXCOLPF2
STACOLPF1
JMPDLIOUT
;
OVER6CMP#1
BNEOVER2
LDATRCOLR;green tree color
EORCOLRSH
ANDDRKMSK
TAX
LDA#$1A;yellow band at top of map
EORCOLRSH
ANDDRKMSK
STAWSYNC
STACOLBAK
STXCOLPF0
LDA#CHRSET/256
STACHBASE
JMPDLIOUT
;
OVER2CMP#3
BNEOVER3
LDAEARTH;top of map
EORCOLRSH
ANDDRKMSK
STAWSYNC
STACOLBAK
JMPDLIOUT
;
OVER3CMP#$D
BNEOVER4
LDX#$E0;bottom of map
LDA#$22
EORCOLRSH
ANDDRKMSK
STAWSYNC
STACOLPF2
STXCHBASE
JMPDLIOUT
;
OVER4CMP#$E
BNEOVER5
LDA#$8A;bright blue strip
EORCOLRSH
ANDDRKMSK
STAWSYNC
STACOLBAK
JMPDLIOUT
;
OVER5CMP#$10
BNEDLIOUT
LDA#$D4;green bottom
EORCOLRSH
ANDDRKMSK
PHA;some extra delay
PLA
NOP
STACOLBAK
;
DLIOUTPLA
TAX
PLA
RTI
;
;SUBROUTINE FOGUP
;fogs up displayed strengths
;
FOGUPCPX#NOGERM
BCCDNUMBR
STATEMPD
LDAINTEL-NOGERM,X
EOR#$FF
STATEMPI
LDAVBISRV,X
EORTURN
ANDTEMPI
LDX#$FF
LSRTEMPI
SEC
SBCTEMPI
BCSZ52
LDX#1
Z52CLC
ADCTEMPD
BCCZ48
CPX#$FF
BNEDNUMBR
TXA
Z48CPX#1
BNEDNUMBR
TXA
;
;just let it run into DNUMBR
;
;SUBROUTINE DNUMBR
;displays a number with leading zero suppress
;
DNUMBRLDX#$FF
STXTEMPD
SEC
LOOP43INX
SBC#100
BCCX62
INCTEMPD
JMPLOOP43
X62PHA
TXA
BEQX61
ADC#$10
STATXTWDW,Y
INY
X61PLA
ADC#100
LDX#$FF
SEC
LOOP44INX
SBC#10
BCSLOOP44
PHA
TXA
BNEX72
BITTEMPD
BMIX73
X72ADC#$10
STATXTWDW,Y
INY
X73PLA
ADC#$1A
STATXTWDW,Y
INY
RTS
;
