10 ;CFT  VERSION 1.7M (MAINLINE ROUTINES) AUGUST 17, 1981
20 ;
30 ;Page zero RAM
40  *=$B0
50 ;
60 ;These locations are used by the interrupt service routine
70 ;
80 DLSTPT *=*+2 Zero page pointer to display list
90 MAPLO *=*+1
0100 MAPHI *=*+1
0110 CORPS *=*+1 number of unit under window
0120 CURSXL *=*+1
0130 CURSXH *=*+1
0140 CURSYL *=*+1 cursor coordinates on screen (map frame)
0150 CURSYH *=*+1
0160 OFFLO *=*+1 How far to offset new LMS value
0170 OFFHI *=*+1
0180 TEMPI *=*+1 An all-purpose temporary register
0190 CNT1 *=*+1 DLI counter
0200 CNT2 *=*+1 DLI counter for movable map DLI
0210 CHUNKX *=*+1 cursor coordinates (pixel frame)
0220 CHUNKY *=*+1
0230 ;
0240 ;These locations are for the mainline routines
0250 ;
0260 MAPPTR *=*+2
0270 ARMY *=*+1
0280 UNITNO *=*+1
0290 DEFNDR *=*+1
0300 TEMPR *=*+1
0310 TEMPZ *=*+1
0320 ACCLO *=*+1
0330 ACCHI *=*+1
0340 TURN *=*+1
0350 LAT *=*+1
0360 LONG *=*+1
0370 RFR *=*+1
0380 TRNTYP *=*+1
0390 SQVAL *=*+1
0400 ;
0410 ;OS locations (see OS manual)
0420 ;
0430 SDMCTL=$022F
0440 DLSTLO=$0230 Existing OS pointer to display list
0450 DLSTHI=$0231
0460 GPRIOR=$026F
0470 PCOLR0=$02C0
0480 PCOLR1=$02C1
0490 PCOLR2=$02C2
0500 PCOLR3=$02C3
0510 COLOR0=$02C4
0520 COLOR1=$02C5
0530 COLOR4=$02C8
0540 CHBAS=$02F4
0550 ;
0560 ;HARDWARE LOCATIONS
0570 ;
0580 HPOSP0=$D000
0590 SIZEP0=$D008
0600 SIZEP1=$D009
0610 TRIG0=$D010
0620 COLPF0=$D016
0630 COLPF1=$D017
0640 COLPF2=$D018
0650 COLPF3=$D019
0660 COLBAK=$D01A
0670 GRACTL=$D01D
0680 RANDOM=$D20A
0690 HSCROL=$D404
0700 VSCROL=$D405
0710 PMBASE=$D407
0720 NMIEN=$D40E
0730 SETVBV=$E45C
0740 XITVBV=$E462
0750 ;
0760 ;Page 6 usage
0770 ;
0780  *=$0600
0790 ;first come locations used by the interrupt service routine
0800 XPOSL *=*+1 Horizontal position of
0810 YPOSL *=*+1 Vertical position of
0820 YPOSH *=*+1 upper left corner of screen window
0830 SCY *=*+1 vert position of cursor (player frame)
0840 SHPOS0 *=*+1 shadows player 0 position
0850 TRCOLR *=*+1
0860 EARTH *=*+1
0870 ICELAT *=*+1
0880 SEASN1 *=*+1
0890 SEASN2 *=*+1
0900 SEASN3 *=*+1
0910 DAY *=*+1
0920 MONTH *=*+1
0930 YEAR *=*+1
0940 BUTFLG *=*+1
0950 BUTMSK *=*+1
0960 TYL *=*+1
0970 TYH *=*+1
0980 DELAY *=*+1 acceleration delay on scrolling
0990 TIMSCL *=*+1 frame to scroll in
1000 TEMPLO *=*+1 temporary
1010 TEMPHI *=*+1
1020 BASEX *=*+1 starting position for arrow (player frame)
1030 BASEY *=*+1
1040 STEPX *=*+1 intermediate position of arrow
1050 STEPY *=*+1
1060 STPCNT *=*+1 which intermediate steps arrow is on
1070 ORDCNT *=*+1 which order arrow is showing
1080 ORD1 *=*+1 orders record
1090 ORD2 *=*+1
1100 ARRNDX *=*+1 arrow index
1110 HOWMNY *=*+1 how many orders for unit under cursor
1120 KRZX *=*+1 maltakreuze coords (player frame)
1130 KRZY *=*+1
1140 DBTIMR *=*+1 joystick debounce timer
1150 STICKI *=*+1
1160 ERRFLG *=*+1
1170 KRZFLG *=*+1
1180 STKFLG *=*+1
1190 HITFLG *=*+1
1200 TXL *=*+1 temporary values---slightly shifted
1210 TXH *=*+1
1220 ;
1230 ;THESE VALUES ARE USED BY MAINLINE ROUTINE ONLY
1240 ;
1250 OLDLAT *=*+1
1260 TRNCOD *=*+1
1270 TLO *=*+1
1280 THI *=*+1
1290 TICK *=*+1
1300 UNTCOD *=*+1
1310 UNTCD1 *=*+1
1320 ;
1330 HANDCP=$68F
1340 ZOC=$694
1350 VICTRY=$697
1360 ;
1370 ;declarations of routines in other modules
1380 ;
1390 CHKZOC=$1140
1400 LOGSTC=$1091
1410 DNUMBR=$3BB2
1420 DWORDS=$39C0
1430 SWITCH=$39EF
1440 YINC=$3BF1
1450 XINC=$3BF2
1460 ;
1470  *=$1200
1480 PLYR0 *=*+128
1490 PLYR1 *=*+128
1500 PLYR2 *=*+128
1510 PLYR3 *=*+128 currently unused
1520 CORPSX *=*+159 x-coords of all units (pixel frame)
1530 CORPSY *=*+159 y-coords of all units (pixel frame)
1540 MSTRNG *=*+159 muster strengths
1550 CSTRNG *=*+159 combat strengths
1560 SWAP *=*+159 terrain code underneath unit
1570 ARRIVE *=*+159 turn of arrival
1580 WORDS *=*+272 various words for messages
1590 CORPT *=*+159 codes for unit types
1600 CORPNO *=*+159 ID numbers of units
1610 HDIGIT *=*+256 tables for displaying numbers (hundreds)
1620 TDIGIT *=*+256 tens tables
1630 ODIGIT *=*+256 ones tables
1640 TXTTBL *=*+96 more text
1650 MONLEN *=*+13 table of month lengths
1660 HMORDS *=*+159 how many orders each unit has in queue
1670 WHORDS *=*+159 what the orders are
1680 WHORDH *=*+159
1690 BEEPTB *=*+4 table of beep tones
1700 ERRMSG *=*+128 table of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decoding orders
1740 XADD *=*+4 offsets for moving arrow
1750 YADD *=*+4
1760 TRTAB *=*+13
1770 MLTKRZ *=*+8 maltese cross shape
1780 ;
1790 ;RAM from $6000 to $6430 is taken up by
1800 ;character sets and the display list
1810 ;
1820  *=$2431
1830 ARRTAB *=*+32 arrow shapes
1840  *=$2450
1850 TXTWDW *=$2CB1
1860 STKTAB *=*+16 a joystick decoding table
1870 SSNCOD *=*+12
1880 TRNTAB *=*+60
1890 BHX1 *=*+22
1900 BHY1 *=*+22
1910 BHX2 *=*+22
1920 BHY2 *=*+22
1930 EXEC *=*+159
1940 ;
1950 ;everything in here is taken up by the map data
1960 ;
1970 ;
1980 ;This is the initialization program
1990 ;The program begins here
2000 ;
2010  *=$2E00
2020 ;
2030  LDX #$08
2040 BOOP99 LDA ZPVAL,X initialize page zero values
2050  STA DLSTPT,X
2060  LDA COLTAB,X
2070  STA PCOLR0,X
2080  DEX
2090  BPL BOOP99
2100 ;
2110  LDX #$0F
2120 BOOP98 LDA PSXVAL,X initialize page six values
2130  STA XPOSL,X
2140  DEX
2150  BPL BOOP98
2160 ;
2170  LDA #$00
2180  STA DLSTLO
2190  STA HSCROL
2200  STA VSCROL
2210  LDA DLSTPT+1
2220  STA DLSTHI
2230 ;
2240  LDX #$00
2250 LOOP22 LDA MSTRNG,X
2260  STA CSTRNG,X
2270  LDA #$00
2280  STA HMORDS,X
2290  LDA #$FF
2300  STA EXEC,X
2310  INX
2320  CPX #$A0
2330  BNE LOOP22
2340 ;
2350 ;
2360 ;Now set up player window
2370 ;
2380  LDA #$10
2390  STA PMBASE
2400 ;
2410 ;here follow various initializations
2420 ;
2430  LDA #$2F
2440  STA SDMCTL
2450  LDA #$03
2460  STA GRACTL
2470  LDA #$78
2480  STA HPOSP0
2490  LDA #$01
2500  STA HANDCP
2510  STA GPRIOR
2520  STA SIZEP0
2530  LDX #$33
2540 ;
2550  LDA #$FF
2560  STA PLYR0,X
2570  INX
2580  STA PLYR0,X
2590  INX
2600  LDA #$81
2610 LOOP2 STA PLYR0,X
2620  INX
2630  CPX #$3F
2640  BNE LOOP2
2650  LDA #$FF
2660  STA PLYR0,X
2670  STA TURN
2680  INX
2690  STA PLYR0,X
2700 ;
2710 ;Now enable deferred vertical blank interrupt
2720 ;
2730  LDY #$00
2740  LDX #$34
2750  LDA #$07
2760  JSR SETVBV
2770  LDA #$00 This is DLI vector (low byte)
2780  STA $0200
2790  LDA #$3B
2800  STA $0201
2810  LDA #$C0
2820  STA NMIEN Turn interrupts on
2830 ;
2840 NEWTRN INC TURN
2850 ;
2860 ;first do calendar calculations
2870 ;
2880  LDA DAY
2890  CLC
2900  ADC #07
2910  LDX MONTH
2920  CMP MONLEN,X
2930  BEQ X28
2940  BCC X28
2950  CPX #$02
2960  BNE X96
2970  LDY YEAR
2980  CPY #44
2990  BNE X96
3000  SEC
3010  SBC #$01
3020 X96 SEC
3030  SBC MONLEN,X
3040  INX
3050  CPX #13
3060  BNE X29
3070  INC YEAR
3080  LDX #01
3090 X29 STX MONTH
3100  LDY TRTAB,X
3110  STY TRCOLR
3120 X28 STA DAY
3130  LDY #$93
3140  LDA #$00
3150 LOOP13 STA TXTWDW,Y
3160  INY
3170  CPY #$A7
3180  BNE LOOP13
3190  LDY #$93
3200  TXA
3210  CLC
3220  ADC #$10
3230  JSR DWORDS
3240  LDA DAY
3250  JSR DNUMBR
3260  LDA #$0C
3270  STA TXTWDW,Y
3280  INY
3290  INY
3300  LDA #$11
3310  STA TXTWDW,Y
3320  INY
3330  LDA #$19
3340  STA TXTWDW,Y
3350  INY
3360  LDX YEAR
3370  LDA #$14
3380  STA TXTWDW,Y
3390  INY
3400  LDA ODIGIT,X
3410  CLC
3420  ADC #$10
3430  STA TXTWDW,Y
3440 ;
3450 ;now do season calculations
3460 ;
3470  LDA MONTH
3480  CMP #$04
3490  BNE X87
3500  LDA #$02
3510  STA EARTH
3520  LDA #$40
3530  STA SEASN1
3540  LDA #$01
3550  STA SEASN3
3560  LDA #$00
3570  STA SEASN2
3580  JMP ENDSSN
3590 X87 CMP #$0A
3600  BNE X88
3610  LDA #$02
3620  STA EARTH
3630  JMP ENDSSN
3640 X88 CMP #$05
3650  BNE X89
3660  LDA #$10
3670  STA EARTH
3680  JMP ENDSSN
3690 X89 CMP #$0B
3700  BNE X90
3710  LDA #$0A
3720  STA EARTH
3730  JMP X91
3740 X90 CMP #$01
3750  BNE X92
3760  LDA #$80
3770  STA SEASN1
3780  LDA #$FF
3790  STA SEASN2
3800  STA SEASN3
3810  JMP ENDSSN
3820 X92 CMP #$03
3830  BEQ X91
3840  JMP ENDSSN
3850 ;
3860 ;
3870 ;freeze those rivers, baby
3880 ;
3890 X91 LDA RANDOM
3900  AND #$07
3910  CLC
3920  ADC #$07
3930  EOR SEASN2
3940  STA TEMPR
3950  LDA ICELAT
3960  STA OLDLAT
3970  SEC
3980  SBC TEMPR
3990  BEQ X95
4000  BPL X94
4010 X95 LDA #$01
4020 X94 CMP #$27
4030  BCC X93
4040  LDA #$27
4050 X93 STA ICELAT
4060  LDA #$01
4070  STA CHUNKX
4080  STA LONG
4090  LDA OLDLAT
4100  STA CHUNKY
4110  STA LAT
4120 ;
4130 LOOP40 JSR TERR
4140 ;
4150  AND #$3F
4160  CMP #$0B
4170  BCC NOTCH
4180  CMP #$29
4190  BCS NOTCH
4200  LDX CHUNKY
4210  CPX #$0E
4220  BCS DOTCH
4230  CMP #$23
4240  BCS NOTCH
4250 DOTCH ORA SEASN1
4260  LDX UNITNO
4270  BEQ X86
4280  STA SWAP,X
4290  JMP NOTCH
4300 X86 STA (MAPPTR),Y
4310 NOTCH INC CHUNKX
4320  LDA CHUNKX
4330  STA LONG
4340  CMP #46
4350  BNE LOOP40
4360  LDA #$00
4370  STA CHUNKX
4380  STA LONG
4390  LDA CHUNKY
4400  CMP ICELAT
4410  BEQ ENDSSN
4420  SEC
4430  SBC SEASN3
4440  STA CHUNKY
4450  STA LAT
4460  JMP LOOP40
4470 ;
4480 ENDSSN LDX #$9E any reinforcements?
4490 LOOP14 LDA ARRIVE,X
4500  CMP TURN
4510  BNE X33
4520  LDA CORPSX,X
4530  STA CHUNKX
4540  STA LONG
4550  LDA CORPSY,X
4560  STA CHUNKY
4570  STA LAT
4580  STX CORPS
4590  JSR TERRB
4600  BEQ SORRY
4610  CPX #$37
4620  BCS A51
4630  LDA #$0A
4640  STA TXTWDW+36
4650 A51 JSR SWITCH
4660  JMP X33
4670 SORRY LDA TURN
4680  CLC
4690  ADC #$01
4700  STA ARRIVE,X
4710 X33 DEX
4720  BNE LOOP14
4730 ;
4740 X31 LDX #$9E
4750 LOOPF STX ARMY
4760  JSR LOGSTC logistics subroutine
4770  LDX ARMY
4780  DEX
4790  BNE LOOPF
4800 ;
4810 ;calculate some points
4820 ;
4830  LDA #$00
4840  STA ACCLO
4850  STA ACCHI
4860  LDX #$01
4870 LOOPB LDA #$30
4880  SEC
4890  SBC CORPSX,X
4900  STA TEMPR
4910  LDA MSTRNG,X
4920  LSR A
4930  BEQ A01
4940  TAY
4950  LDA #$00
4960  CLC
4970 LOOPA ADC TEMPR
4980  BCC A0
4990  INC ACCHI
5000  CLC
5010  BNE A0
5020  DEC ACCHI
5030 A0 DEY
5040  BNE LOOPA
5050 A01 INX
5060  CPX #$37
5070  BNE LOOPB
5080 ;
5090 LOOPC LDA CORPSX,X
5100  STA TEMPR
5110  LDA CSTRNG,X
5120  LSR A
5130  LSR A
5140  LSR A
5150  BEQ A02
5160  TAY
5170  LDA #$00
5180  CLC
5190 LOOPD ADC TEMPR
5200  BCC A03
5210  INC ACCLO
5220  CLC
5230  BNE A03
5240  DEC ACCLO
5250 A03 DEY
5260  BNE LOOPD
5270 A02 INX
5280  CPX #$9E
5290  BNE LOOPC
5300 ;
5310  LDA ACCHI
5320  SEC
5330  SBC ACCLO
5340  BCS A04
5350  LDA #$00
5360 A04 LDX #$03
5370 LOOPG LDY MOSCOW,X
5380  BEQ A15
5390  CLC
5400  ADC MPTS,X
5410  BCC A15
5420  LDA #$FF
5430 A15 DEX
5440  BPL LOOPG
5450 ;
5460  LDX HANDCP was handicap option used?
5470  BNE A23 no
5480  LSR A yes, halve score
5490 A23 LDY #$05
5500  JSR DNUMBR
5510  LDA #$00
5520  STA TXTWDW,Y
5530  LDA TURN
5540  CMP #$28
5550  BNE Z00
5560  LDA #$01 end of game
5570  JSR TXTMSG
5580 FINI JMP FINI hang up
5590 ;
5600 ;
5610 Z00 LDA #$00
5620  STA BUTMSK
5630  STA CORPS
5640  JSR TXTMSG
5650  JSR $0700 artificial intelligence routine
5660  LDA #$01
5670  STA BUTMSK
5680  LDA #$02
5690  JSR TXTMSG
5700 ;
5710 ;movement execution phase
5720 ;
5730  LDA #$00
5740  STA TICK
5750  LDX #$9E
5760 LOOP31 STX ARMY
5770  JSR DINGO determine first execution time
5780  DEX
5790  BNE LOOP31
5800 ;
5810 LOOP33 LDX #$9E
5820 LOOP32 STX ARMY
5830  LDA MSTRNG,X
5840  SEC
5850  SBC CSTRNG,X
5860  CMP #$02
5870  BCC Y30
5880  INC CSTRNG,X
5890  CMP RANDOM
5900  BCC Y30
5910  INC CSTRNG,X
5920 Y30 LDA EXEC,X
5930  BMI A60
5940  CMP TICK
5950  BNE A60
5960  LDA WHORDS,X
5970  AND #$03
5980  TAY
5990  LDA CORPSX,X
6000  CLC
6010  ADC XINC,Y
6020  STA LONG
6030  STA ACCLO
6040  LDA CORPSY,X
6050  CLC
6060  ADC YINC,Y
6070  STA LAT
6080  STA ACCHI
6090  JSR TERR
6100  LDA UNITNO
6110  BEQ DOMOVE
6120  CMP #$37
6130  BCC GERMAN
6140  LDA ARMY
6150  CMP #$37
6160  BCS TRJAM
6170  BCC COMBAT
6180 GERMAN LDA ARMY
6190  CMP #$37
6200  BCS COMBAT
6210 TRJAM LDX ARMY
6220  LDA TICK
6230  CLC
6240  ADC #$02
6250  STA EXEC,X
6260 A60 JMP Y06
6270 COMBAT JSR $0ED8
6280  LDA VICTRY
6290  BEQ A60
6300  BNE Z94
6310 DOMOVE LDX ARMY
6320  STX CORPS
6330  LDA CORPSY,X
6340  STA CHUNKY
6350  STA LAT
6360  LDA CORPSX,X
6370  STA CHUNKX
6380  STA LONG
6390  JSR CHKZOC
6400  LDA ACCHI
6410  STA LAT
6420  LDA ACCLO
6430  STA LONG
6440  LDA ZOC
6450  CMP #$02
6460  BCC Z94
6470  JSR CHKZOC
6480  LDA ZOC
6490  CMP #$02
6500  BCS TRJAM
6510 Z94 JSR SWITCH
6520  LDX CORPS
6530  LDA LAT
6540  STA CHUNKY
6550  STA CORPSY,X
6560  LDA LONG
6570  STA CHUNKX
6580  STA CORPSX,X
6590  JSR SWITCH
6600  LDX ARMY
6610  LDA #$FF
6620  STA EXEC,X
6630  DEC HMORDS,X
6640  BEQ Y06
6650  LSR WHORDH,X
6660  ROR WHORDS,X
6670  LSR WHORDH,X
6680  ROR WHORDS,X
6690  LDY #$03
6700 LOOPH LDA CORPSX,X
6710  CMP MOSCX,Y
6720  BNE A18
6730  LDA CORPSY,X
6740  CMP MOSCY,Y
6750  BNE A18
6760  LDA #$FF
6770  CPX #$37
6780  BCC A19
6790  LDA #$00
6800 A19 STA MOSCOW,Y
6810 A18 DEY
6820  BPL LOOPH
6830 ;
6840  JSR DINGO
6850  JSR STALL
6860 Y06 LDX ARMY
6870  DEX
6880  BEQ Y07
6890  JMP LOOP32
6900 Y07 INC TICK
6910  LDA TICK
6920  CMP #$20
6930  BEQ Y08
6940  JMP LOOP33
6950 ;
6960 ;end of movement phase
6970 ;
6980 Y08 JMP NEWTRN
6990 ;
7000 MOSCOW .BYTE 0,0,0,0
7010 ;
7020  *=$3200
7030 STALL LDA #$00
7040 LOOP79 PHA
7050  PLA
7060  PHA
7070  PLA
7080  PHA
7090  PLA
7100  ADC #$01
7110  BNE LOOP79
7120  RTS
7130 ;
7140 ;this is the debugging routine
7150 ;it can't be reached by any route any longer
7160 ;
7170 ;
7180  *=$3210
7190  LDA #$00
7200  STA $D01D
7210  STA $D00D
7220  STA $D00E
7230  STA $D00F
7240  LDA #$22
7250  STA $22F
7260  LDA #$20
7270  STA $230
7280  LDA #$BC
7290  STA $231
7300  LDA #$40
7310  STA NMIEN
7320  LDA #$0A
7330  STA $2C5
7340  LDA #$00
7350  STA $5FFF
7360  STA $2C8
7370  BRK
7380 ;
7390 ;
7400 ;
7410 ;Subroutine TERR determines what terrain is in a square
7420 ;
7430  *=$3240
7440 ;
7450 TERR JSR TERRB
7460  BEQ LOOKUP
7470  RTS
7480 TERRB LDA #$00
7490  STA MAPPTR+1
7500  STA UNITNO
7510  LDA #$27
7520  SEC
7530  SBC LAT
7540  ASL A
7550  ROL MAPPTR+1
7560  ASL A
7570  ROL MAPPTR+1
7580  ASL A
7590  ROL MAPPTR+1
7600  ASL A
7610  ROL MAPPTR+1
7620  STA TLO
7630  LDY MAPPTR+1
7640  STY THI
7650  ASL A
7660  ROL MAPPTR+1
7670  CLC
7680  ADC TLO
7690  STA MAPPTR
7700  LDA MAPPTR+1
7710  ADC THI
7720  ADC #$25
7730  STA MAPPTR+1
7740  LDA #46
7750  SEC
7760  SBC LONG
7770  TAY
7780  LDA (MAPPTR),Y
7790  STA TRNCOD
7800  AND #$3F
7810  CMP #$3D
7820  BEQ A80
7830  CMP #$3E
7840 A80 RTS
7850 ;
7860 LOOKUP LDA TRNCOD
7870  STA UNTCOD
7880  AND #$C0
7890  LDX #$9E
7900  CMP #$40
7910  BNE X98
7920  LDX #$37
7930 X98 LDA LAT
7940 LOOP30 CMP CORPSY,X
7950  BEQ MIGHTB
7960 X97 DEX
7970  BNE LOOP30
7980  LDA #$FF
7990  STA TXTWDW+128
8000  BMI MATCH
8010 MIGHTB LDA LONG
8020  CMP CORPSX,X
8030  BNE X99
8040  LDA CSTRNG,X
8050  BEQ X99
8060  LDA ARRIVE,X
8070  BMI X99
8080  CMP TURN
8090  BCC MATCH
8100  BEQ MATCH
8110 X99 LDA LAT
8120  JMP X97
8130 MATCH STX UNITNO
8140  LDA SWAP,X
8150  STA TRNCOD
8160  RTS
8170 ;
8180 ;determines execution time of next move
8190 ;
8200 DINGO LDX ARMY
8210  LDA HMORDS,X
8220  BNE Y00
8230  LDA #$FF
8240  STA EXEC,X
8250  RTS
8260 Y00 LDA CORPSX,X
8270  STA LONG
8280  LDA CORPSY,X
8290  STA LAT
8300  JSR TERR
8310  LDA UNTCOD
8320  STA UNTCD1
8330  LDX ARMY
8340  LDA WHORDS,X
8350  EOR #$02
8360  AND #$03
8370  TAY
8380  LDA CORPSX,X
8390  CLC
8400  ADC XADD,Y
8410  STA LONG
8420  LDA CORPSY,X
8430  CLC
8440  ADC YADD,Y
8450  STA LAT
8460  JSR TERR
8470  JSR TERRTY
8480  LDA UNTCD1
8490  AND #$3F
8500  LDX #$00
8510  CMP #$3D
8520  BEQ Y01 infantry
8530  LDX #$0A armor
8540 Y01 TXA
8550  LDX MONTH
8560  CLC
8570  ADC SSNCOD-1,X add season index
8580  ADC TRNTYP add terrain index
8590  TAX
8600  LDA TRNTAB,X get net delay
8610  CLC
8620  ADC TICK
8630  LDX ARMY
8640  STA EXEC,X
8650  LDA TRNTYP
8660  CMP #$07
8670  BCC Y02
8680  LDY #$15
8690 LOOP35 LDA LAT
8700  CMP BHY1,Y
8710  BNE Y03
8720  LDA LONG
8730  CMP BHX1,Y
8740  BNE Y03
8750  LDX ARMY
8760  LDA CORPSX,X
8770  CMP BHX2,Y
8780  BNE Y03
8790  LDA CORPSY,X
8800  CMP BHY2,Y
8810  BNE Y03
8820  LDA #$FF
8830  STA EXEC,X
8840  RTS
8850 Y03 DEY
8860  BPL LOOP35
8870 Y02 RTS
8880 ;
8890 ;this subroutine determines the type of terrain
8900 ;in a square
8910 ;
8920 TERRTY LDY #$00
8930  LDA TRNCOD
8940  BEQ DONE
8950  CMP #$7F border?
8960  BNE Y04
8970  LDY #$09
8980  BNE DONE
8990 Y04 INY
9000  CMP #$07 mountain?
9010  BCC DONE
9020  INY
9030  CMP #$4B city?
9040  BCC DONE
9050  INY
9060  CMP #$4F frozen swamp?
9070  BCC DONE
9080  INY
9090  CMP #$69 frozen river?
9100  BCC DONE
9110  INY
9120  CMP #$8F swamp?
9130  BCC DONE
9140  INY
9150  CMP #$A4 river?
9160  BCC DONE
9170  LDX LAT
9180  CPX #$0E
9190  BCC NEXT
9200  CMP #$A9
9210  BCC DONE
9220 NEXT INY
9230  CMP #$BA coastline?
9240  BCC DONE
9250  CPX #$0E
9260  BCC NEXT2
9270  CMP #$BB
9280  BCC DONE
9290 NEXT2 INY
9300  CMP #$BD estuary?
9310  BCC DONE
9320  INY
9330 DONE STY TRNTYP
9340  RTS
9350 ZPVAL .BYTE 0,$24,0,0,0,$22,1,$30,2
9360 PSXVAL .BYTE $E0,0,0,$33,$78,$D6,$10,$27
9370  .BYTE $40,0,1,15,6,41,0,1
9380 COLTAB .BYTE $58,$DC,$2F,0,$6A,$C,$94,$46,$B0
9390 MPTS .BYTE 20,10,10,10
9400 MOSCX .BYTE 20,33,20,6
9410 MOSCY .BYTE 28,36,0,15
9420 TXTMSG ASL A
9430  ASL A
9440  ASL A
9450  ASL A
9460  ASL A
9470  TAX
9480  LDY #$69
9490 LOOP19 LDA TXTTBL,X
9500  SEC
9510  SBC #$20
9520  STA TXTWDW,Y
9530  INY
9540  INX
9550  TXA
9560  AND #$1F
9570  BNE LOOP19
9580  RTS
9590  .END
