;
;EFT VERSION 36E (EQUATES) JANUARY 29, 1983
;
;declarations of program constants
;
BASE=$9000
NORUSS=119
NOGERM=48
NOUNTS=NORUSS+NOGERM-1
NOFLIG=43
LAGTIM=30
MODPLC=$24
MSGPLC=$6A
NOZPVL=$1E
CRITRG=6
;
;Page zero OS RAM
;
RTCLKL=$14
ATRACT=$4D
DRKMSK=$4E
COLRSH=$4F
;
;page zero program RAM
;
ORG$80
;
DLSTPTORG*+2
CURSXLORG*+1
CURSXHORG*+1
CURSYLORG*+1
CURSYHORG*+1
XPOSLORG*+1
SCYORG*+1
SHPOS0ORG*+1
TRCOLRORG*+1
EARTHORG*+1
ICELATORG*+1
SEASN1ORG*+1
SEASN2ORG*+1
SEASN3ORG*+1
DAYORG*+1
MONTHORG*+1
TURNORG*+1
LEVELORG*+1
SCENROORG*+1
YPOSLORG*+1
YPOSHORG*+1
BUTFLGORG*+1
BUTMSKORG*+1
ARRGSHORG*+1
ARRRSHORG*+1
ARRGSLORG*+1
ARRRSLORG*+1
MAPBASORG*+1
TOTGSORG*+1
TOTRSORG*+1
;
MAPLOORG*+1
MAPHIORG*+1
CORPSORG*+1
OFFLOORG*+1
OFFHIORG*+1
TEMPIORG*+1
CNT1ORG*+1
CNT2ORG*+1
CHUNKXORG*+1
CHUNKYORG*+1
MAPPTRORG*+2
ARMYORG*+1
UNITNOORG*+1
DEFNDRORG*+1
TEMPRORG*+1
ACCLOORG*+1
ACCHIORG*+1
LATORG*+1
LONGORG*+1
RFRORG*+1
TRNTYPORG*+1
SQVALORG*+1
TYLORG*+1
NRDYFGORG*+1
DELAYORG*+1
TIMSCLORG*+1
TEMPLOORG*+1
TEMPHIORG*+1
BASEXORG*+1
BASEYORG*+1
STEPXORG*+1
STEPYORG*+1
STPCNTORG*+1
ORDCNTORG*+1
ORD1ORG*+1
ORD2ORG*+1
ARRNDXORG*+1
HOWMNYORG*+1
KRZXORG*+1
KRZYORG*+1
DBTIMRORG*+1
STICKIORG*+1
ERRFLGORG*+1
KRZFLGORG*+1
STKFLGORG*+1
HITFLGORG*+1
TXLORG*+1
LODFLGORG*+1
NBVALORG*+1
RORD1ORG*+1
RORD2ORG*+1
HDIRORG*+1
LDIRORG*+1
SDIRORG*+1
HRNGEORG*+1
LRNGEORG*+1
SRNGEORG*+1
CHRISORG*+1
RANGEORG*+1
RCNTORG*+1
SECDIRORG*+1
IFR0ORG*+1
IFR1ORG*+1
IFR2ORG*+1
IFR3ORG*+1
TEMPXORG*+1
TEMPYORG*+1
LPTSORG*+1
IFRHIORG*+1
OFRORG*+1
OLDLATORG*+1
TRNCODORG*+1
TLOORG*+1
THIORG*+1
TICKORG*+1
UNTCODORG*+1
UNTCD1ORG*+1
ZOCORG*+1
VICTRYORG*+1
HOMEDRORG*+1
BVALORG*+1
BONEORG*+1
DIRORG*+1
TEMPDORG*+1
TARGXORG*+1
TARGYORG*+1
BUTLAGORG*+1
PRODLOORG*+1
PRODHIORG*+1
DIVISRORG*+1
PASFLGORG*+1
VPOSORG*+1
HPOSORG*+1
RPTIMRORG*+1
FROGORG*+1
ENDFLGORG*+1
;
;
SDMCTL=$22F
DLSTLO=$230
DLSTHI=$231
GPRIOR=$26F
PCOLR0=$2C0
PCOLR1=$2C1
PCOLR2=$2C2
STICK=$278
CHART=$2F3
CH=$2FC
ICCMD2=$362
ICSTA2=$363
ICBAL2=$364
ICBAH2=$365
ICBLL2=$368
ICBLH2=$369
ICAX12=$36A
ICAX22=$36B
;
;
HPOSP0=$D000
HPOSP1=$D001
HPOSP2=$D002
HPOSP3=$D003
SIZEP0=$D008
TRIG0=$D010
TRIG1=$D011
COLPF0=$D016
COLPF1=$D017
COLPF2=$D018
COLBAK=$D01A
VDELAY=$D01C
GRACTL=$D01D
CONSOL=$D01F
AUDF1=$D200
AUDC1=$D201
RANDOM=$D20A
SKCTL=$D20F
HSCROLL=$D404
VSCROLL=$D405
PMBASE=$D407
WSYNC=$D40A
CHBASE=$D409
NMIEN=$D40E
CIOV=$E456
SETVBV=$E45C
XITVBV=$E462
;
ORG$2200
;
PLYR0ORG*+128
PLYR1ORG*+128
PLYR2ORG*+128
PLYR3ORG*+128
;
MAPDATORG*+1969
CORPSXORG*+NOUNTS+1
CORPSYORG*+NOUNTS+1
MSTRNGORG*+NOUNTS+1
ARRIVEORG*+NOUNTS+1
CORPTORG*+NOUNTS+1
CORPNOORG*+NOUNTS+1
ZPVALORG*+NOZPVL+1
DLISTORG*+49
COLTABORG*+9
CITABORG*+5
MBLOODORG*+5
CBLOODORG*+5
FOGTABORG*+5
GREINFORG*+5
RREINFORG*+5
ENDGAMORG*+6
LBOOSTORG*+5
WINSCRORG*+5
CALENORG*+5
YEARORG*+1
;
LVORG*+5
BAKARRORG*+25
LINARRORG*+25
BUFFERORG*+9
SFBUFORG*+9
SCBUFORG*+9
TOUCHDORG*+NOGERM+1
AIRBSTORG*+NOGERM+1
EXECORG*+NOUNTS+1
SWAPORG*+NOUNTS+2
CSTRNGORG*+NOUNTS+1
HMORDSORG*+NOUNTS+1
WHORDSORG*+NOUNTS+1
WHORDHORG*+NOUNTS+1
MODEORG*+NOUNTS+1
OBJXORG*+NORUSS+1
OBJYORG*+NORUSS+1
IFRORG*+NORUSS+1
IFRNORG*+NORUSS+1
IFREORG*+NORUSS+1
IFRSORG*+NORUSS+1
IFRWORG*+NORUSS+1
INTELORG*+NORUSS+1
CLOSEORG*+NORUSS+1
CLOSE1ORG*+NORUSS+1
TXTWDWORG*+144
TOPWDWORG*+24
MOSCOWORG*+18
;
REINSP=TXTWDW+139
